#!/usr/local/bin/perl
#
# $Header: /usr/local/CVS/perl-modules/CGI/FormChecker/Examples/sample.cgi,v 1.1 2001/11/05 06:18:50 matisse Exp $
# RCS Tag: $Name:  $
#
#
# $Log: sample.cgi,v $
# Revision 1.1  2001/11/05 06:18:50  matisse
# added FormChecker
#
# Revision 1.1.1.1  2001/03/09 18:30:14  matisse
# imported source code
#
###############################################################################

use strict;
use Carp qw( confess cluck );
use CGI::FormChecker;
use CGI qw( :cgi );

my $r = CGI->new;
my $fc = CGI::FormChecker->new;
my $Template = $ENV{PATH_TRANSLATED};
$fc->{Parser}->template_file("$Template");

unless ( $ENV{REQUEST_METHOD} eq "POST" ) {
    _show_template($r, $fc, $Template);
    exit;
}

$fc->TemplateFile($Template);

# Each rule is a referece to a subroutine, which will be called with
# all the arguments specified in CheckInput
my $rules = [
    sub { check_length( $r, 'name', '5', '15') },
    sub { check_length( $r, 'address', '2', '3') },
];

my $errors = $fc->CheckInput($rules, $r);
#
# $rules is a ref-to-array of subroutine references.
# All the arguments after  $rules   will be passed to each rule.
# E.g.  $fc->CheckInput(\@rules, $a, \@b, \%c);  would cause each
# subroutine in  @rules  to be called with 3 arguments.

print $r->header;
if (%$errors ) {
    print $fc->ErrorHandler($errors);
} else {
    $fc->{Parser}->add_tag( MESSAGE => "OK" );
    $fc->{Parser}->add_tag( ERROR => "" );
    print $fc->{Parser}->parse_file;
}

# All done


sub check_length {
    my( $r, $field, $min, $max ) = @_;
    my $length = length $r->param("$field");
    my %errors;
    if( $length ) {
        # The field has at least 1 character
        $errors{"${field}_too_long"} = 1 if $length > $max;
        $errors{"${field}_too_short"} = 1 if $length < $min;
    } else {
        $errors{"${field}_missing"} = 1;
    }
    return \%errors if ( %errors );
    return undef;  # No errors
}


sub _show_template {
    my($r, $fc, $t) = @_;
    $fc->{Parser}->unknown_action("");
    print $r->header;
    print $fc->{Parser}->parse_file;
}
