# $Header: /usr/local/CVS/perl-modules/CGI/FormChecker/test.pl,v 1.1 2001/11/05 06:18:50 matisse Exp $
# RCS Tag: $Name:  $
#
#
# $Log: test.pl,v $
# Revision 1.1  2001/11/05 06:18:50  matisse
# added FormChecker
#
# Revision 1.1.1.1  2001/03/09 18:30:14  matisse
# imported source code
#
###############################################################################

# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

use strict;
use lib 'blib/lib';
use FormChecker;
$| = 1;
my $num_tests = 5;
my $fc;

my $DefaultMessage = "Message From Template String";
my $TemplateString = <<"EOF";
<#ERROR TEST="test" TEXT="$DefaultMessage">
EOF

print "1..$num_tests\n";

my( %Succeeded, %Failed );
foreach my $test ( 1..$num_tests ) {
    print "test $test\t";
    eval "test$test($test)";
}
# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

sub test1 {
    my $test = shift;
    print "Creating a new object... ";
    $fc = CGI::FormChecker->new;
    if ( ref $fc eq "CGI::FormChecker" ) {
        $Succeeded{$test}++;
        print "ok\n";
    } else {
        $Failed{$test}++;
        print "failed\n";
    }
}
    
sub  test2 {
    my $test = shift;
    print "Define a string to use as a template... ";
    $fc->TemplateString( $TemplateString );
    if ( $fc->TemplateString eq "$TemplateString" ) {
        $Succeeded{$test}++;
        print "ok\n";
    } else {
        $Failed{$test}++;
        print "failed\n";
    }
}

sub  test3 {
    my $test = shift;
    print "CheckInput with good input... ";
    my @args = ( 1, 2 );
    my $tests = [
        sub { my( $min, $max ) = @_ ; return undef if $min < $max;
              return { 'test' => 'default msg for test' } },
    ];
    my $errors = $fc->CheckInput( $tests, @args );
    unless ( %$errors ) {
        $Succeeded{$test}++;
        print "ok\n";
    } else {
        $Failed{$test}++;
        print "failed\n";
    }
}

sub  test4 {
    my $test = shift;
    print "CheckInput with bad input... ";
    my @args = ( 1, 1 );
    my $tests = [
        sub { my( $min, $max ) = @_ ; return undef if $min < $max;
              return { 'test' => 'default msg for test' } },
    ];
    my $errors = $fc->CheckInput( $tests, @args );
    if ( %$errors ) {
        $Succeeded{$test}++;
        print "ok (Returned: $errors->{test} )\n";
    } else {
        $Failed{$test}++;
        print "failed\n";
    }
}

sub  test5 {
    my $test = shift;
    print "CheckInput with bad input and parse template... ";
    my @args = ( 2, 1 );
    my $tests = [
        sub { my( $min, $max ) = @_ ; return undef if $min < $max;
              return { 'test' => 'default msg for test' } },
    ];
    my $errors_hash_ref = $fc->CheckInput( $tests, @args );
    my $output = $fc->ErrorHandler($errors_hash_ref);
    if ( $output eq "$DefaultMessage\n" ) {
        $Succeeded{$test}++;
        print "ok\nReturned: $output\n";
    } else {
        $Failed{$test}++;
        print "failed\n";
        print "Expected: $DefaultMessage\n";
        print "Returned: $output\n";
    }
}

